<template>
    <div class="container is-fluid">
        <div id="app">
            <!--<img alt="Vue logo" src="./assets/logo.png">-->
            <Header/>
            <AddToDoItem v-on:add-todo="addTodo"/>
            <ToDoList :ToDoList="ToDos"
                      v-on:del-todo="deleteToDoItem"
                      v-on:markDone="markDone"
            />
        </div>
    </div>
</template>

<script>
    import ToDoList from './components/ToDoList.vue'
    import Header from './components/Header.vue'
    import AddToDoItem from './components/AddToDoItem.vue'
    import axios from 'axios'

    const encodeForm = (data) => {
        return Object.keys(data)
            .map(key => encodeURIComponent(key) + '=' + encodeURIComponent(data[key]))
            .join('&');
    };

    export default {
        name: 'app',
        components: {
            ToDoList,
            Header,
            AddToDoItem,
        },
        data() {
            return {
                app_title: 'Todo App',
                base_url: 'http://localhost:8000/api/task/',
                ToDos: [],
            };
        },
        methods: {
            deleteToDoItem(id) {
                axios.delete(this.base_url + id).then(res => {
                    console.log(res);
                    this.ToDos = this.ToDos.filter(todo => todo.id !== id)
                })
                    .catch(err => console.log(err));
            },
            addTodo(newToDo) {

                axios.post(this.base_url, encodeForm(newToDo))
                    .then(res => {
                        console.log(res);
                        this.fetchList();
                    })
                    .catch(err => console.log(err));
            },
            markDone(todo) {
                const updateToDo = {
                                    is_complete: 1
                                };
                axios.put(this.base_url + todo.id, encodeForm(updateToDo))
                    .then(res => {
                        console.log(res);
                        this.ToDos.filter((todoItem) => {
                            if( todoItem.id === todo.id ) todoItem.is_complete = 1;
                        });
                    })
                    .catch(err => console.log(err));
            },
            fetchList() {
                axios.get(this.base_url)
                    .then(res => this.ToDos = res.data)
                    .catch(err => console.log(err));
            }
        },
        created() {
            this.fetchList();
        }
    }
</script>

<style lang="scss">
    #app {
        font-family: 'Avenir', Helvetica, Arial, sans-serif;
        -webkit-font-smoothing: antialiased;
        -moz-osx-font-smoothing: grayscale;
        text-align: center;
        color: #2c3e50;
    }

    @import "../node_modules/bulma/bulma.sass";

    .container.is-fluid {
        max-width: none;
        padding-left: 16px;
        padding-right: 16px;
        width: 100%;
    }
    header {
        margin: 1rem;
    }
    .section {
        padding: 1rem 1rem;
    }
</style>
